Subject: Re: [PATCH 36/38] netfilter: connlimit: use keyed locks

From: Jesper Dangaard Brouer <[email-masked]>
Date: Tue, 18 Mar 2014 14:46:16 +0100

On Mon, 17 Mar 2014 07:00:08 -0700
Eric Dumazet <[email-masked]> wrote:

> On Mon, 2014-03-17 at 13:42 +0100, Pablo Neira Ayuso wrote:
> > From: Florian Westphal <[email-masked]>
> > 
> > connlimit currently suffers from spinlock contention, example for
> > 4-core system with rps enabled:
> 
> > +#define CONNLIMIT_SLOTS	256
> > +#define CONNLIMIT_LOCK_SLOTS	32
> 
> 
> 
> 32 spinlocks use 2 cache lines (assuming 4 bytes per spinlock, and 64
> bytes cache lines)

Hehe, I actually also pointed this out during my internal review, but
we never gotten around to fixing this.

> So I guess this probably should be increased to have less false sharing.
> 
> Note: This can be done later, I do not want to block this patch serie at
> all !

Yes, lets fix it up later.

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Sr. Network Kernel Developer at Red Hat
  Author of http://www.iptv-analyzer.org
  LinkedIn: http://www.linkedin.com/in/brouer